/*    $ DOOROOS: AppMain.c v 0.1 2005/11/11 $    */

/*
 * Copyright (C) 2015    iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: AppMain.c
 *
 * Purpose: Create the user application.
 *
 */

#include <types.h>
#include <thread.h>
#include <memory.h>
#include <window.h>

#include <panic.h>

#include <taskheap.h>

//=======================================================================================

#define DBG_LVL     1


#define APP_MAINSTACK_SIZE (4096*10)
STATIC INT32        AppMain( UINT32 Arg );
PUBLIC TASKCONFIG   TaskConfig 
                                    = 
                                    {
                                        NULL,
                                        AppMain,
                                        (PBYTE)NULL,
                                        APP_MAINSTACK_SIZE,
                                        THREAD_PRIORITY_USER_HIGH + 2
                                    }
                                        ;

//=======================================================================================

// should return the task handle
INT32
main( VOID )
{
	HANDLE hTask;
    // start the applications...
    DBGLINE(DBG_LVL, "util_hmiext Start+\n");    

    hTask = TaskCreate( &TaskConfig );
    DBGLINE(DBG_LVL, "util_hmiext : hTask = %x\n", hTask);

    return hTask;
}


EXTERN HWND CreateWindow_HmiExtWnd( HWND hParentWnd );


STATIC INT32
AppMain( UINT32 Arg )
{
	HWND	hWnd;
	
    DBGLINE(DBG_LVL, "Start AppMain(util_hmiext) \n");

	TaskHeapInit( 512<<MEMPOOL_SHIFT );	// 2MB

    GL_Open();
    DBGLINE(DBG_LVL, "DOOROOS GL_Open\n");    

    hWnd = CreateWindow_HmiExtWnd(NULL);

	// register the task main window 
	// this window is called on re-execution
	TaskWindowSet( ThreadGetHandle(), hWnd );

	MessageLoop();

    return 0;
}



